// D import file generated from 'derelict/devil/ilu.d'
module derelict.devil.ilu;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	import derelict.devil.il;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "ilu.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libILU.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libILU.so";
			}
			else
			{
				static assert(0, "Need to implement ILU libNames for this operating system.");
			}
		}
	}
}
enum : ILenum
{
	ILU_VERSION_1_7_8 = 1,
	ILU_VERSION = 178,
	ILU_FILTER = 9728,
	ILU_NEAREST = 9729,
	ILU_LINEAR = 9730,
	ILU_BILINEAR = 9731,
	ILU_SCALE_BOX = 9732,
	ILU_SCALE_TRIANGLE = 9733,
	ILU_SCALE_BELL = 9734,
	ILU_SCALE_BSPLINE = 9735,
	ILU_SCALE_LANCZOS3 = 9736,
	ILU_SCALE_MITCHELL = 9737,
	ILU_INVALID_ENUM = 1281,
	ILU_OUT_OF_MEMORY = 1282,
	ILU_INTERNAL_ERROR = 1284,
	ILU_INVALID_VALUE = 1285,
	ILU_ILLEGAL_OPERATION = 1286,
	ILU_INVALID_PARAM = 1289,
	ILU_PLACEMENT = 1792,
	ILU_LOWER_LEFT = 1793,
	ILU_LOWER_RIGHT = 1794,
	ILU_UPPER_LEFT = 1795,
	ILU_UPPER_RIGHT = 1796,
	ILU_CENTER = 1797,
	ILU_CONVOLUTION_MATRIX = 1808,
	ILU_VERSION_NUM = IL_VERSION_NUM,
	ILU_VENDOR = IL_VENDOR,
	ILU_ENGLISH = 2048,
	ILU_ARABIC = 2049,
	ILU_DUTCH = 2050,
	ILU_JAPANESE = 2051,
	ILU_SPANISH = 2052,
	ILU_GERMAN = 2053,
	ILU_FRENCH = 2054,
}
struct ILinfo
{
	ILuint Id;
	ILubyte* Data;
	ILuint Width;
	ILuint Height;
	ILuint Depth;
	ILubyte Bpp;
	ILuint SizeOfData;
	ILenum Format;
	ILenum Type;
	ILenum Origin;
	ILubyte* Palette;
	ILenum PalType;
	ILuint PalSize;
	ILenum CubeFlags;
	ILuint NumNext;
	ILuint NumMips;
	ILuint NumLayers;
}
struct ILpointf
{
	ILfloat x;
	ILfloat y;
}
struct ILpointi
{
	ILint x;
	ILint y;
}
extern (C) nothrow @nogc 
{
	alias ILboolean function() da_iluAlienify;
	alias ILboolean function(ILuint) da_iluBlurAvg;
	alias ILboolean function(ILuint) da_iluBlurGaussian;
	alias ILboolean function() da_iluBuildMipmaps;
	alias ILuint function() da_iluColoursUsed;
	alias ILboolean function(ILuint) da_iluCompareImage;
	alias ILboolean function(ILfloat) da_iluContrast;
	alias ILboolean function(ILuint, ILuint, ILuint, ILuint, ILuint, ILuint) da_iluCrop;
	alias void function(ILuint) da_iluDeleteImage;
	alias ILboolean function() da_iluEdgeDetectE;
	alias ILboolean function() da_iluEdgeDetectP;
	alias ILboolean function() da_iluEdgeDetectS;
	alias ILboolean function() da_iluEmboss;
	alias ILboolean function(ILuint, ILuint, ILuint) da_iluEnlargeCanvas;
	alias ILboolean function(ILfloat, ILfloat, ILfloat) da_iluEnlargeImage;
	alias ILboolean function() da_iluEqualize;
	alias ILconst_string function(ILenum) da_iluErrorString;
	alias ILboolean function(ILint*, ILint, ILint) da_iluConvolution;
	alias ILboolean function() da_iluFlipImage;
	alias ILboolean function(ILfloat) da_iluGammaCorrect;
	alias ILuint function() da_iluGenImage;
	alias void function(ILinfo*) da_iluGetImageInfo;
	alias ILint function(ILenum) da_iluGetInteger;
	alias void function(ILenum, ILint*) da_iluGetIntegerv;
	alias ILstring function(ILenum) da_iluGetString;
	alias void function(ILenum, ILenum) da_iluImageParameter;
	alias void function() da_iluInit;
	alias ILboolean function() da_iluInvertAlpha;
	alias ILuint function(ILconst_string) da_iluLoadImage;
	alias ILboolean function() da_iluMirror;
	alias ILboolean function() da_iluNegative;
	alias ILboolean function(ILclampf) da_iluNoisify;
	alias ILboolean function(ILuint) da_iluPixelize;
	alias void function(ILpointf*, ILuint) da_iluRegionfv;
	alias void function(ILpointi*, ILuint) da_iluRegioniv;
	alias ILboolean function(ILubyte, ILubyte, ILubyte, ILfloat) da_iluReplaceColour;
	alias ILboolean function(ILfloat) da_iluRotate;
	alias ILboolean function(ILfloat, ILfloat, ILfloat, ILfloat) da_iluRotate3D;
	alias ILboolean function(ILfloat) da_iluSaturate1f;
	alias ILboolean function(ILfloat, ILfloat, ILfloat, ILfloat) da_iluSaturate4f;
	alias ILboolean function(ILuint, ILuint, ILuint) da_iluScale;
	alias ILboolean function(ILfloat) da_iluScaleAlpha;
	alias ILboolean function(ILfloat, ILfloat, ILfloat) da_iluScaleColours;
	alias ILboolean function(ILenum) da_iluSetLanguage;
	alias ILboolean function(ILfloat, ILuint) da_iluSharpen;
	alias ILboolean function() da_iluSwapColours;
	alias ILboolean function(ILfloat) da_iluWave;
}

__gshared 
{
	da_iluAlienify iluAlienify;
	da_iluBlurAvg iluBlurAvg;
	da_iluBlurGaussian iluBlurGaussian;
	da_iluBuildMipmaps iluBuildMipmaps;
	da_iluColoursUsed iluColoursUsed;
	da_iluCompareImage iluCompareImage;
	da_iluContrast iluContrast;
	da_iluCrop iluCrop;
	da_iluDeleteImage iluDeleteImage;
	da_iluEdgeDetectE iluEdgeDetectE;
	da_iluEdgeDetectP iluEdgeDetectP;
	da_iluEdgeDetectS iluEdgeDetectS;
	da_iluEmboss iluEmboss;
	da_iluEnlargeCanvas iluEnlargeCanvas;
	da_iluEnlargeImage iluEnlargeImage;
	da_iluEqualize iluEqualize;
	da_iluErrorString iluErrorString;
	da_iluConvolution iluConvolution;
	da_iluFlipImage iluFlipImage;
	da_iluGammaCorrect iluGammaCorrect;
	da_iluGenImage iluGenImage;
	da_iluGetImageInfo iluGetImageInfo;
	da_iluGetInteger iluGetInteger;
	da_iluGetIntegerv iluGetIntegerv;
	da_iluGetString iluGetString;
	da_iluImageParameter iluImageParameter;
	da_iluInit iluInit;
	da_iluInvertAlpha iluInvertAlpha;
	da_iluLoadImage iluLoadImage;
	da_iluMirror iluMirror;
	da_iluNegative iluNegative;
	da_iluNoisify iluNoisify;
	da_iluPixelize iluPixelize;
	da_iluRegionfv iluRegionfv;
	da_iluRegioniv iluRegioniv;
	da_iluReplaceColour iluReplaceColour;
	da_iluRotate iluRotate;
	da_iluRotate3D iluRotate3D;
	da_iluSaturate1f iluSaturate1f;
	da_iluSaturate4f iluSaturate4f;
	da_iluScale iluScale;
	da_iluScaleAlpha iluScaleAlpha;
	da_iluScaleColours iluScaleColours;
	da_iluSetLanguage iluSetLanguage;
	da_iluSharpen iluSharpen;
	da_iluSwapColours iluSwapColours;
	da_iluWave iluWave;
	alias iluColoursUsed iluColorsUsed;
	alias iluSwapColours iluSwapColors;
	alias iluReplaceColour iluReplaceColor;
	alias iluScaleColours iluScaleColors;
}
class DerelictILULoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();

}
__gshared DerelictILULoader DerelictILU;

shared static this();
