// D import file generated from 'derelict/devil/ilut.d'
module derelict.devil.ilut;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	import derelict.devil.il;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "ilut.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libILUT.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libILUT.so";
			}
			else
			{
				static assert(0, "Need to implement ILUT libNames for this operating system.");
			}
		}
	}
}
enum : ILenum
{
	ILUT_VERSION_1_7_8 = 1,
	ILUT_VERSION = 178,
	ILUT_OPENGL_BIT = 1,
	ILUT_D3D_BIT = 2,
	ILUT_ALL_ATTRIB_BITS = 1048575,
	ILUT_INVALID_ENUM = 1281,
	ILUT_OUT_OF_MEMORY = 1282,
	ILUT_INVALID_VALUE = 1285,
	ILUT_ILLEGAL_OPERATION = 1286,
	ILUT_INVALID_PARAM = 1289,
	ILUT_COULD_NOT_OPEN_FILE = 1290,
	ILUT_STACK_OVERFLOW = 1294,
	ILUT_STACK_UNDERFLOW = 1295,
	ILUT_BAD_DIMENSIONS = 1297,
	ILUT_NOT_SUPPORTED = 1360,
	ILUT_PALETTE_MODE = 1536,
	ILUT_OPENGL_CONV = 1552,
	ILUT_D3D_MIPLEVELS = 1568,
	ILUT_MAXTEX_WIDTH = 1584,
	ILUT_MAXTEX_HEIGHT = 1585,
	ILUT_MAXTEX_DEPTH = 1586,
	ILUT_GL_USE_S3TC = 1588,
	ILUT_D3D_USE_DXTC = 1588,
	ILUT_GL_GEN_S3TC = 1589,
	ILUT_D3D_GEN_DXTC = 1589,
	ILUT_S3TC_FORMAT = 1797,
	ILUT_DXTC_FORMAT = 1797,
	ILUT_D3D_POOL = 1798,
	ILUT_D3D_ALPHA_KEY_COLOR = 1799,
	ILUT_D3D_ALPHA_KEY_COLOUR = 1799,
	ILUT_FORCE_INTEGER_FORMAT = 1590,
	ILUT_GL_AUTODETECT_TEXTURE_TARGET = 2055,
	ILUT_VERSION_NUM = IL_VERSION_NUM,
	ILUT_VENDOR = IL_VENDOR,
	ILUT_OPENGL = 0,
	ILUT_ALLEGRO = 1,
	ILUT_WIN32 = 2,
	ILUT_DIRECT3D8 = 3,
	ILUT_DIRECT3D9 = 4,
	ILUT_X11 = 5,
	ILUT_DIRECT3D10 = 6,
}
extern (C) 
{
	alias ILboolean function(ILenum) da_ilutDisable;
	alias ILboolean function(ILenum) da_ilutEnable;
	alias ILboolean function(ILenum) da_ilutGetBoolean;
	alias void function(ILenum, ILboolean*) da_ilutGetBooleanv;
	alias ILint function(ILenum) da_ilutGetInteger;
	alias void function(ILenum, ILint*) da_ilutGetIntegerv;
	alias ILstring function(ILenum) da_ilutGetString;
	alias void function() da_ilutInit;
	alias ILboolean function(ILenum) da_ilutIsDisabled;
	alias ILboolean function(ILenum) da_ilutIsEnabled;
	alias void function() da_ilutPopAttrib;
	alias void function(ILuint) da_ilutPushAttrib;
	alias void function(ILenum, ILint) da_ilutSetInteger;
	alias ILboolean function(ILenum) da_ilutRenderer;
	alias uint function() da_ilutGLBindTexImage;
	alias uint function() da_ilutGLBindMipmaps;
	alias ILboolean function() da_ilutGLBuildMipmaps;
	alias uint function(ILstring FileName) da_ilutGLLoadImage;
	alias ILboolean function() da_ilutGLScreen;
	alias ILboolean function() da_ilutGLScreenie;
	alias ILboolean function(ILstring, uint) da_ilutGLSaveImage;
	alias ILboolean function(uint) da_ilutGLSetTex;
	alias ILboolean function(uint) da_ilutGLTexImage;
	alias ILboolean function(uint, ILuint, ILuint) da_ilutGLSubTex;
	version (Windows)
	{
		private import derelict.util.wintypes;

		alias HBITMAP function(HDC hDC) da_ilutConvertToHBitmap;
		alias void function(ILubyte* Data) da_ilutFreePaddedData;
		alias void function(BITMAPINFO* Info) da_ilutGetBmpInfo;
		alias HPALETTE function() da_ilutGetHPal;
		alias ILubyte* function() da_ilutGetPaddedData;
		alias ILboolean function() da_ilutGetWinClipboard;
		alias ILboolean function(HINSTANCE hInst, ILint ID, ILstring ResourceType, ILenum Type) da_ilutLoadResource;
		alias ILboolean function(HBITMAP Bitmap) da_ilutSetHBitmap;
		alias ILboolean function(HPALETTE Pal) da_ilutSetHPal;
		alias ILboolean function() da_ilutSetWinClipboard;
		alias HBITMAP function(ILstring FileName, HDC hDC) da_ilutWinLoadImage;
		alias ILboolean function(ILstring Url) da_ilutWinLoadUrl;
		alias ILboolean function(ILuint XPos, ILuint YPos, ILuint Width, ILuint Height, HDC hDC) da_ilutWinPrint;
		alias ILboolean function(ILstring FileName, HBITMAP Bitmap) da_ilutWinSaveImage;
	}
	version (Linux)
	{
	}
}
__gshared 
{
	da_ilutDisable ilutDisable;
	da_ilutEnable ilutEnable;
	da_ilutGetBoolean ilutGetBoolean;
	da_ilutGetBooleanv ilutGetBooleanv;
	da_ilutGetInteger ilutGetInteger;
	da_ilutGetIntegerv ilutGetIntegerv;
	da_ilutGetString ilutGetString;
	da_ilutInit ilutInit;
	da_ilutIsDisabled ilutIsDisabled;
	da_ilutIsEnabled ilutIsEnabled;
	da_ilutPopAttrib ilutPopAttrib;
	da_ilutPushAttrib ilutPushAttrib;
	da_ilutSetInteger ilutSetInteger;
	da_ilutRenderer ilutRenderer;
	da_ilutGLBindTexImage ilutGLBindTexImage;
	da_ilutGLBindMipmaps ilutGLBindMipmaps;
	da_ilutGLBuildMipmaps ilutGLBuildMipmaps;
	da_ilutGLLoadImage ilutGLLoadImage;
	da_ilutGLScreen ilutGLScreen;
	da_ilutGLScreenie ilutGLScreenie;
	da_ilutGLSaveImage ilutGLSaveImage;
	da_ilutGLSetTex ilutGLSetTex;
	da_ilutGLTexImage ilutGLTexImage;
	da_ilutGLSubTex ilutGLSubTex;
	version (Windows)
	{
		da_ilutConvertToHBitmap ilutConvertToHBitmap;
		da_ilutFreePaddedData ilutFreePaddedData;
		da_ilutGetBmpInfo ilutGetBmpInfo;
		da_ilutGetHPal ilutGetHPal;
		da_ilutGetPaddedData ilutGetPaddedData;
		da_ilutGetWinClipboard ilutGetWinClipboard;
		da_ilutLoadResource ilutLoadResource;
		da_ilutSetHBitmap ilutSetHBitmap;
		da_ilutSetHPal ilutSetHPal;
		da_ilutSetWinClipboard ilutSetWinClipboard;
		da_ilutWinLoadImage ilutWinLoadImage;
		da_ilutWinLoadUrl ilutWinLoadUrl;
		da_ilutWinPrint ilutWinPrint;
		da_ilutWinSaveImage ilutWinSaveImage;
	}
}
class DerelictILUTLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();

}
__gshared DerelictILUTLoader DerelictILUT;

shared static this();
